## kf6-extra-cmake-modules 6.20.0

=== CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2006-2013 Alex Neundorf <neundorf@kde.org>
# SPDX-FileCopyrightText: 2014-2015 Alex Merry <alex.merry@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause
#=============================================================================

cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

#
# Preliminary setup
#

set(VERSION "6.20.0") # handled by release scripts

project(ECM
    VERSION "${VERSION}"
    LANGUAGES NONE
)

#
# Includes
#

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(FeatureSummary)


#
# Installation paths
#

set(SHARE_INSTALL_DIR share
    CACHE
    PATH
    "read-only architecture-independent data"
)

set(CMAKECONFIG_INSTALL_DIR       ${SHARE_INSTALL_DIR}/ECM/cmake/)

set(FIND_MODULES_INSTALL_DIR      ${SHARE_INSTALL_DIR}/ECM/find-modules/)
set(KDE_MODULES_INSTALL_DIR       ${SHARE_INSTALL_DIR}/ECM/kde-modules)
set(MODULES_INSTALL_DIR           ${SHARE_INSTALL_DIR}/ECM/modules/)
set(TOOLCHAIN_MODULES_INSTALL_DIR ${SHARE_INSTALL_DIR}/ECM/toolchain/)

set(DOC_INSTALL_DIR ${SHARE_INSTALL_DIR}/doc/ECM
    CACHE
    PATH
    "HTML and QtHelp documentation"
)
set(MAN_INSTALL_DIR ${SHARE_INSTALL_DIR}/man
    CACHE
    PATH
    "man pages"
)


#
# Documentation
#

option(BUILD_DOC "Build documentation." ON)
add_feature_info(BUILD_DOC BUILD_DOC "Build documentation.")
if(BUILD_DOC)
    add_subdirectory(docs)
endif()


#
# Tests
#

option(BUILD_TESTING "Build automated tests." ON)
add_feature_info(BUILD_TESTING BUILD_TESTING "Build automated tests.")
if(BUILD_TESTING)
    enable_testing()
    add_subdirectory(tests)
endif()


#
# Install modules
#

file(GLOB installModuleFiles ${CMAKE_SOURCE_DIR}/modules/*[^~])
install(FILES ${installModuleFiles} DESTINATION ${MODULES_INSTALL_DIR})

file(GLOB installTestModuleFiles ${CMAKE_SOURCE_DIR}/test-modules/*[^~])
install(FILES ${installTestModuleFiles} DESTINATION ${SHARE_INSTALL_DIR}/ECM/test-modules)

file(GLOB installKdeModuleFiles LIST_DIRECTORIES FALSE ${CMAKE_SOURCE_DIR}/kde-modules/*[^~])
install(FILES ${installKdeModuleFiles} DESTINATION ${KDE_MODULES_INSTALL_DIR})
# The scripts need to be executable
file(GLOB installKDECommitHooks ${CMAKE_SOURCE_DIR}/kde-modules/kde-git-commit-hooks/*[^~])
install(PROGRAMS ${installKDECommitHooks} DESTINATION ${KDE_MODULES_INSTALL_DIR}/kde-git-commit-hooks)

file(GLOB installFindModuleFiles ${CMAKE_SOURCE_DIR}/find-modules/*.cmake ${CMAKE_SOURCE_DIR}/find-modules/*.py)
install(FILES ${installFindModuleFiles} DESTINATION ${FIND_MODULES_INSTALL_DIR})

file(GLOB installToolchainModuleFiles ${CMAKE_SOURCE_DIR}/toolchain/*[^~])
install(FILES ${installToolchainModuleFiles} DESTINATION ${TOOLCHAIN_MODULES_INSTALL_DIR})


#
# Config.cmake file
#

include(CMakePackageConfigHelpers)

configure_package_config_file(
    ECMConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/ECMConfig.cmake
    INSTALL_DESTINATION
        ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS
        FIND_MODULES_INSTALL_DIR
        KDE_MODULES_INSTALL_DIR
        MODULES_INSTALL_DIR
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/ECMConfigVersion.cmake
    VERSION
        "${PROJECT_VERSION}"
    COMPATIBILITY
        AnyNewerVersion
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/ECMConfig.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/ECMConfigVersion.cmake
    DESTINATION
        ${CMAKECONFIG_INSTALL_DIR}
)


#
# Packaging
#

set(CPACK_PACKAGE_NAME extra-cmake-modules)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_SYSTEM_NAME "generic")
set(CPACK_GENERATOR "TGZ")
set(CPACK_SET_DESTDIR FALSE)

include(CPack)


#
# Feature summary
#

feature_summary(
    FATAL_ON_MISSING_REQUIRED_PACKAGES
    WHAT ALL
)

=== tests/KDEPackageAppTemplatesForcedTest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
set(ECM_KDE_MODULE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../kde-modules)
set(ECM_MODULE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../modules)
set(CMAKE_MODULE_PATH "${ECM_KDE_MODULE_DIR}")

set(CMAKE_CROSSCOMPILING ON)
include(KDEPackageAppTemplates)

message(STATUS "Test: generate compressed template")
kde_package_app_templates(TEMPLATES "qml-plasmoid" INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR})

# this will be run by CTest
configure_file(check.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/check.cmake" @ONLY)

=== tests/ECMGeneratePkgConfigFile/no_description_parameter_metainfo_with_description-param/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(no_description_parameter_metainfo_with_description-param VERSION 5.43)

include(../test-and-comparison-helpers.cmake)

include(ECMGeneratePkgConfigFile)
include(ECMSetupVersion)

ecm_setup_version(PROJECT VARIABLE_PREFIX KCOREADDONS
                VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kcoreaddons_version.h"
                PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5CoreAddonsConfigVersion.cmake"
                SOVERSION 5)

set(origfiles "${CMAKE_CURRENT_SOURCE_DIR}/../../../tests/ECMGeneratePkgConfigFile/KF5CoreAddons2.pc")

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../../../tests/ECMGeneratePkgConfigFile/metainfo_with_description.yaml
     DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
file(RENAME ${CMAKE_CURRENT_SOURCE_DIR}/metainfo_with_description.yaml ${CMAKE_CURRENT_SOURCE_DIR}/metainfo.yaml)

ecm_generate_pkgconfig_file(BASE_NAME KF5CoreAddons2
                            DEPS Qt5Core
                            INCLUDE_INSTALL_DIR /usr/KCoreAddons
                            FILENAME_VAR OutputFile)

compare_files(GENERATED ${OutputFile}
              ORIGINALS ${origfiles})
file(REMOVE ${OutputFile})
file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/metainfo.yaml)

=== tests/ECMGeneratePkgConfigFile/test_imported_targets/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(ECMGeneratePkgConfigFile_imported_vars VERSION 0.1)

set(ECM_MODULE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../../modules")
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../modules;${CMAKE_CURRENT_SOURCE_DIR}/../../../kde-modules")

enable_language(CXX)

include(ECMGeneratePkgConfigFile)
include(ECMSetupVersion)

# KDEInstallDirs can't be used
set(EGPF_KDE_INSTALL_INCLUDEDIR_KF "include/KF6")

set(InputFile "${CMAKE_CURRENT_SOURCE_DIR}/EGPF_imported_include_dirs_control.pc")

set(CMAKE_INSTALL_PREFIX "/usr")
set(CMAKE_INSTALL_LIBDIR "lib")

ecm_setup_version(0.1 VARIABLE_PREFIX EGPF_lib
                SOVERSION 0)

add_library(EGPF_lib)
target_sources(EGPF_lib PRIVATE main.cpp)
set_target_properties(EGPF_lib PROPERTIES
    VERSION 0.1
    SOVERSION 0
    EXPORT_NAME "EGPF_lib"
)

target_include_directories(EGPF_lib INTERFACE "$<INSTALL_INTERFACE:${EGPF_KDE_INSTALL_INCLUDEDIR_KF}/Attica;${EGPF_KDE_INSTALL_INCLUDEDIR_KF}/EGPF_lib;${EGPF_KDE_INSTALL_INCLUDEDIR_KF}/other_dir>"
    PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../:${CMAKE_CURRENT_BINARY_DIR}/..>"
)

ecm_generate_pkgconfig_file(BASE_NAME EGPF_lib
                            DESCRIPTION "Testing additional include dirs in Cflags"
                            INCLUDE_INSTALL_DIR ${EGPF_KDE_INSTALL_INCLUDEDIR_KF}/Attica/
                            FILENAME_VAR OutputFile
                            )

add_test(
    NAME ECMGeneratePkgConfigFileTest.imported_include_dirs
    COMMAND ${CMAKE_COMMAND} -E compare_files --ignore-eol "${InputFile}" "${OutputFile}"
    )

=== tests/ECMGeneratePkgConfigFile/with_public_and_private_dependencies/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(with_public_and_private_dependencies VERSION 5.43)

include(../test-and-comparison-helpers.cmake)

include(ECMGeneratePkgConfigFile)
include(ECMSetupVersion)

ecm_setup_version(PROJECT VARIABLE_PREFIX KCOREADDONS
                VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kcoreaddons_version.h"
                PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5CoreAddonsConfigVersion.cmake"
                SOVERSION 5)

set(origfiles "${CMAKE_CURRENT_SOURCE_DIR}/../../../tests/ECMGeneratePkgConfigFile/KF5CoreAddons4.pc")

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../../../tests/ECMGeneratePkgConfigFile/metainfo_without_description.yaml
     DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
file(RENAME ${CMAKE_CURRENT_SOURCE_DIR}/metainfo_without_description.yaml ${CMAKE_CURRENT_SOURCE_DIR}/metainfo.yaml)

ecm_generate_pkgconfig_file(BASE_NAME KF5CoreAddons4
                            DEPS Public1 PRIVATE Private1 Private2 PUBLIC Public2
                            INCLUDE_INSTALL_DIR /usr/KCoreAddons
                            FILENAME_VAR OutputFile)

compare_files(GENERATED ${OutputFile}
              ORIGINALS ${origfiles})
file(REMOVE ${OutputFile})
file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/metainfo.yaml)

=== tests/ECMSetupVersionTest/new_project_header_prefix/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(new_project_header_prefix VERSION 2.3.4)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../../modules)
include(ECMSetupVersion)

ecm_setup_version(PROJECT
    VARIABLE_PREFIX Foo
    VERSION_HEADER "ecm_new_project_header_version.h"
)

include(../version_helpers.cmake)
standard_version_var_checks(Foo 2.3.4)

add_executable(check_header main.c)
target_include_directories(check_header PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

=== tests/KDEInstallDirsTest/not_cache_variable/CMakeLists.txt ===
# Test KDEInstallDirs does not crash if a variable like CMAKE_INSTALL_LIBDIR is
# defined but is not a cache variable.
cmake_minimum_required(VERSION 3.16)

set(ECM_KDE_MODULE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../kde-modules)
set(ECM_MODULE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../modules)
set(CMAKE_MODULE_PATH "${ECM_KDE_MODULE_DIR}")

set(KDE_INSTALL_BINDIR "altbin")
set(CMAKE_INSTALL_DATADIR "altdata")
set(LIB_INSTALL_DIR "altlib")

include(KDEInstallDirs)


include(../var_list.cmake)
include(../../test_helpers.cmake)

message(STATUS "Checking result of setting KDE_INSTALL_BINDIR")
assert_var_str_value(KDE_INSTALL_BINDIR "altbin")
if(should_set_CMAKE_INSTALL_BINDIR)
    assert_var_str_value(CMAKE_INSTALL_BINDIR "altbin")
endif()
if(NOT KDE_INSTALL_DIRS_NO_DEPRECATED)
    assert_var_str_value(BIN_INSTALL_DIR "altbin")
endif()

if(should_set_CMAKE_INSTALL_DATADIR)
    message(STATUS "Checking result of setting CMAKE_INSTALL_DATADIR")
    assert_var_str_value(KDE_INSTALL_DATADIR "altdata")
    assert_var_str_value(CMAKE_INSTALL_DATADIR "altdata")
    if(NOT KDE_INSTALL_DIRS_NO_DEPRECATED)
        assert_var_str_value(DATA_INSTALL_DIR "altdata")
    endif()
endif()

if(NOT KDE_INSTALL_DIRS_NO_DEPRECATED)
    message(STATUS "Checking result of setting LIB_INSTALL_DIR")
    assert_var_str_value(KDE_INSTALL_LIBDIR "altlib")
    if(should_set_CMAKE_INSTALL_LIBDIR)
        assert_var_str_value(CMAKE_INSTALL_LIBDIR "altlib")
    endif()
    assert_var_str_value(LIB_INSTALL_DIR "altlib")
endif()

add_executable(dummy main.c)
set_target_properties(dummy PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
kf6-extra-cmake-modules (6.20.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (6.20.0).

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 15 Nov 2025 19:07:19 +0100

## kf6-extra-cmake-modules 6.20.0+p24.04+vunstable+git20251130.0046

=== debian/changelog ===
kf6-extra-cmake-modules (6.20.0+p24.04+vunstable+git20251130.0046-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 30 Nov 2025 00:46:41 +0000

kf6-extra-cmake-modules (6.20.0-0neon) Noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 22 Nov 2025 15:33:53 +1000

## kf6-extra-cmake-modules 6.20.0+p24.04+vunstable+git20251202.0635

=== debian/changelog ===
kf6-extra-cmake-modules (6.20.0+p24.04+vunstable+git20251202.0635-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 02 Dec 2025 06:35:53 +0000

## kf6-extra-cmake-modules 6.21.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # Preliminary setup
 #
 
-set(VERSION "6.20.0") # handled by release scripts
+set(VERSION "6.21.0") # handled by release scripts
 
 project(ECM
     VERSION "${VERSION}"

=== debian/changelog ===
kf6-extra-cmake-modules (6.21.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.21.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 12 Dec 2025 11:49:12 +0000

kf6-extra-cmake-modules (6.20.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.20.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 13 Nov 2025 16:12:13 +0000

=== debian/control ===
Source: kf6-extra-cmake-modules
Section: devel
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.16~),
               libjs-jquery (>= 3.5.1+dfsg-3) <!nodoc>,
               libjs-underscore <!nodoc>,
               python3-setuptools <!nodoc>,
               python3-sphinx (>= 1.2~) <!nodoc>,
               python3-sphinxcontrib.qthelp <!nodoc>,
               python3-sphinxcontrib.serializinghtml <!nodoc>,
Build-Depends-Indep: dh-sequence-sphinxdoc,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://invent.kde.org/frameworks/extra-cmake-modules
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-extra-cmake-modules
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-extra-cmake-modules

Package: extra-cmake-modules
Architecture: any
Depends: ${misc:Depends},
Suggests: qt6-base-dev,
Description: Extra modules and scripts for CMake
 Extra CMake Modules, or ECM, aims to augment CMake with additional modules. It
 serves as both a staging ground for new modules before they are moved upstream
 to CMake and a place for modules that, for whatever reason, are not a good fit
 for CMake itself.
 .
 It is primarily driven by the needs of the KDE community, but it is hoped that
 other projects will find it useful, and outside contributions are always
 welcome. The main rule for new modules is that there must be at least two
 downstream users.

Package: extra-cmake-modules-doc
Build-Profiles: <!nodoc>
Architecture: all
Multi-Arch: foreign
Section: doc
Built-Using: ${sphinxdoc:Built-Using},
Depends: ${misc:Depends}, ${sphinxdoc:Depends},
Description: Extra modules and scripts for CMake - documentation
 Extra CMake Modules, or ECM, aims to augment CMake with additional modules. It
 serves as both a staging ground for new modules before they are moved upstream
 to CMake and a place for modules that, for whatever reason, are not a good fit
 for CMake itself.
 .
 It is primarily driven by the needs of the KDE community, but it is hoped that
 other projects will find it useful, and outside contributions are always
 welcome. The main rule for new modules is that there must be at least two
 downstream users.
 .
 This package contains HTML documentation and man pages.

## kf6-extra-cmake-modules 6.21.0+p24.04+vstable+git20251218.0056

=== debian/changelog ===
kf6-extra-cmake-modules (6.21.0+p24.04+vstable+git20251218.0056-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 18 Dec 2025 00:56:22 +0000

kf6-extra-cmake-modules (6.21.0-0neon) Noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 07 Dec 2025 15:13:55 +1000

## kf6-extra-cmake-modules 6.22.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # Preliminary setup
 #
 
-set(VERSION "6.21.0") # handled by release scripts
+set(VERSION "6.22.0") # handled by release scripts
 
 project(ECM
     VERSION "${VERSION}"

=== tests/ECMAddTests/single_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(ECMAddTests)

set(ECM_MODULE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../modules)
set(CMAKE_MODULE_PATH "${ECM_MODULE_DIR}")

add_library(testhelper STATIC ../testhelper.cpp)
target_include_directories(testhelper PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/..")

# Link to QtCore for WinMain on Windows
include(QtVersionOption)
find_package(Qt${QT_MAJOR_VERSION}Core REQUIRED)
target_link_libraries(testhelper PUBLIC Qt${QT_MAJOR_VERSION}::Core)

enable_testing()

include(ECMAddTests)
include(../../test_helpers.cmake)

# clean up to avoid false-positives from check_files.cmake
file(REMOVE
    "${CMAKE_CURRENT_BINARY_DIR}/test1.txt"
    "${CMAKE_CURRENT_BINARY_DIR}/test2.txt"
    "${CMAKE_CURRENT_BINARY_DIR}/test3.txt"
    "${CMAKE_CURRENT_BINARY_DIR}/test4.txt"
    "${CMAKE_CURRENT_BINARY_DIR}/test5.txt"
    "${CMAKE_CURRENT_BINARY_DIR}/test6.txt"
    )
file(REMOVE_RECURSE
    "${CMAKE_CURRENT_BINARY_DIR}/test7_dir"
    )

set(exp_target_name "test1")
set(exp_test_name "test1")
ecm_add_test(test1.cpp
    LINK_LIBRARIES testhelper
    TARGET_NAME_VAR target_name
    TEST_NAME_VAR test_name
    )
assert_vars_setequal(target_name exp_target_name)
assert_vars_setequal(test_name exp_test_name)
# check target exists
get_property(_dummy TARGET test1 PROPERTY TYPE)
# check test exists
get_property(_dummy TEST test1 PROPERTY TIMEOUT)
get_property(_is_win32 TARGET test1 PROPERTY WIN32_EXECUTABLE)
if (_is_win32)
    message(FATAL_ERROR "test1 is a WIN32 executable when it should not be")
endif()
get_property(_is_bundle TARGET test1 PROPERTY MACOSX_BUNDLE)
if (_is_bundle)
    message(FATAL_ERROR "test1 is an OS/X bundle when it should not be")
endif()


ecm_add_test(test2.cpp
    LINK_LIBRARIES testhelper
    TEST_NAME named_test
    )
get_property(_dummy TARGET named_test PROPERTY TYPE)
get_property(_dummy TEST named_test PROPERTY TIMEOUT)
get_property(_is_win32 TARGET named_test PROPERTY WIN32_EXECUTABLE)
if (_is_win32)
    message(FATAL_ERROR "named_test is a WIN32 executable when it should not be")
endif()
get_property(_is_bundle TARGET named_test PROPERTY MACOSX_BUNDLE)
if (_is_bundle)
    message(FATAL_ERROR "named_test is an OS/X bundle when it should not be")
endif()


set(exp_target_name "test3")
set(exp_test_name "prefix_test3")
ecm_add_test(test3.cpp
    LINK_LIBRARIES testhelper
    NAME_PREFIX prefix_
    TARGET_NAME_VAR target_name
    TEST_NAME_VAR test_name
    )
assert_vars_setequal(target_name exp_target_name)
assert_vars_setequal(test_name exp_test_name)
get_property(_dummy TARGET test3 PROPERTY TYPE)
get_property(_dummy TEST prefix_test3 PROPERTY TIMEOUT)
get_property(_is_win32 TARGET test3 PROPERTY WIN32_EXECUTABLE)
if (_is_win32)
    message(FATAL_ERROR "test3 is a WIN32 executable when it should not be")
endif()
get_property(_is_bundle TARGET test3 PROPERTY MACOSX_BUNDLE)
if (_is_bundle)
    message(FATAL_ERROR "test3 is an OS/X bundle when it should not be")
endif()


ecm_add_test(test4.cpp
    LINK_LIBRARIES testhelper
    GUI
    )
get_property(_dummy TARGET test4 PROPERTY TYPE)
get_property(_dummy TEST test4 PROPERTY TIMEOUT)
get_property(_is_win32 TARGET test4 PROPERTY WIN32_EXECUTABLE)
if (NOT _is_win32)
    message(FATAL_ERROR "test4 is not a WIN32 executable when it should be")
endif()
get_property(_is_bundle TARGET test4 PROPERTY MACOSX_BUNDLE)
if (NOT _is_bundle)
    message(FATAL_ERROR "test4 is not an OS/X bundle when it should be")
endif()


ecm_add_test(test5.cpp
    LINK_LIBRARIES testhelper
    TEST_NAME combined_test
    NAME_PREFIX another_prefix_
    GUI
    )
get_property(_dummy TARGET combined_test PROPERTY TYPE)
get_property(_dummy TEST another_prefix_combined_test PROPERTY TIMEOUT)
get_property(_is_win32 TARGET combined_test PROPERTY WIN32_EXECUTABLE)
if (NOT _is_win32)
    message(FATAL_ERROR "combined_test is not a WIN32 executable when it should be")
endif()
get_property(_is_bundle TARGET combined_test PROPERTY MACOSX_BUNDLE)
if (NOT _is_bundle)
    message(FATAL_ERROR "combined_test is not an OS/X bundle when it should be")
endif()


ecm_add_test(test6.cpp test6body.cpp
    LINK_LIBRARIES testhelper
    TEST_NAME multifile_test
    )
get_property(_dummy TARGET multifile_test PROPERTY TYPE)
get_property(_dummy TEST multifile_test PROPERTY TIMEOUT)
get_property(_is_win32 TARGET multifile_test PROPERTY WIN32_EXECUTABLE)
if (_is_win32)
    message(FATAL_ERROR "multifile_test is a WIN32 executable when it should not be")
endif()
get_property(_is_bundle TARGET multifile_test PROPERTY MACOSX_BUNDLE)
if (_is_bundle)
    message(FATAL_ERROR "multifile_test is an OS/X bundle when it should not be")
endif()


set(exp_workingdir "${CMAKE_CURRENT_BINARY_DIR}/test7_dir")
file(MAKE_DIRECTORY "${exp_workingdir}") # cmake does not create that for us, will complain otherwise
ecm_add_test(test7.cpp
    LINK_LIBRARIES testhelper
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/test7_dir"
    )
get_property(_dummy TARGET test7 PROPERTY TYPE)
get_property(_dummy TEST test7 PROPERTY TIMEOUT)
get_property(_working_dir TEST test7 PROPERTY WORKING_DIRECTORY)
assert_vars_setequal(_working_dir exp_workingdir)
get_property(_is_win32 TARGET test7 PROPERTY WIN32_EXECUTABLE)
if (_is_win32)
    message(FATAL_ERROR "test7 is a WIN32 executable when it should not be")
endif()
get_property(_is_bundle TARGET test7 PROPERTY MACOSX_BUNDLE)
if (_is_bundle)
    message(FATAL_ERROR "test7 is an OS/X bundle when it should not be")
endif()

set(exp_env "TEST_ENV=1")
ecm_add_test(test8.cpp
    TEST_NAME test8
    LINK_LIBRARIES testhelper
    ENVIRONMENT ${exp_env}
    )
get_property(_env TEST test8 PROPERTY ENVIRONMENT)
assert_vars_setequal(_env exp_env)

set(exp_compile_def "-DTEST_DEF=1")
ecm_add_test(test9.cpp
    TEST_NAME test9
    LINK_LIBRARIES testhelper
    COMPILE_DEFINITIONS ${exp_compile_def}
    )
# The checks are carried out by executing the executable file created

=== tests/ECMAddTests/nameprefix_by_path_tests/dir_a/dir_b/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
# SPDX-License-Identifier: CC0-1.0

# prefix preset by path-derived value
ecm_add_test(
    TEST_NAME "main_b"
    ${main_cpp}
)

# override of path-derived value by explicit arg
ecm_add_test(
    NAME_PREFIX "override_by_arg-"
    TEST_NAME "main_b2"
    ${main_cpp}
)

# override of path-derived value by explicit NO_NAME_PREFIX
ecm_add_test(
    NO_NAME_PREFIX
    TEST_NAME "main_b3"
    ${main_cpp}
)

# check
assert_test_name_prefix("dir_a-dir_b-")

assert_test_name("dir_a-dir_b-" "main_b")
assert_test_name("override_by_arg-" "main_b2")
assert_test_name("" "main_b3")

=== tests/ECMAddTests/nameprefix_by_path_tests/dir_a/dir_first/dir_last/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
# SPDX-License-Identifier: CC0-1.0

ecm_test_set_dir_properties(LAST_PREFIX_NAME)

add_subdirectory(dir_afterlast)

# prefix preset by path-derived value
ecm_add_test(
    TEST_NAME "main_last"
    ${main_cpp}
)

# override of path-derived value by explicit arg
ecm_add_test(
    NAME_PREFIX "override_by_arg-"
    TEST_NAME "main_last2"
    ${main_cpp}
)

# override of path-derived value by explicit NO_NAME_PREFIX
ecm_add_test(
    NO_NAME_PREFIX
    TEST_NAME "main_last3"
    ${main_cpp}
)

# check
assert_test_name_prefix("dir_first-dir_last-")

assert_test_name("dir_first-dir_last-" "main_last")
assert_test_name("override_by_arg-" "main_last2")
assert_test_name("" "main_last3")

=== tests/ECMAddTests/nameprefix_by_path_tests/dir_a/dir_nodirs/nodir_first/nodir_ignored/nodir_notignored/nodir_renamed/nodir_last/dir_afterlast/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
# SPDX-License-Identifier: CC0-1.0

# prefix preset by path-derived value
ecm_add_test(
    TEST_NAME "main_nodir"
    ${main_cpp}
)

# override of path-derived value by explicit arg
ecm_add_test(
    NAME_PREFIX "override_by_arg-"
    TEST_NAME "main_nodir2"
    ${main_cpp}
)

# override of path-derived value by explicit NO_NAME_PREFIX
ecm_add_test(
    NO_NAME_PREFIX
    TEST_NAME "main_nodir3"
    ${main_cpp}
)

# check
assert_test_name_prefix("nodir_first-nodir_notignored-new_name-nodir_last-")

assert_test_name("nodir_first-nodir_notignored-new_name-nodir_last-" "main_nodir")
assert_test_name("override_by_arg-" "main_nodir2")
assert_test_name("" "main_nodir3")

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0-1) unstable; urgency=medium

  [ Boyuan Yang ]
  * Team upload.
  * debian/watch: Update to version 5.
  * debian/control: Bump Standards-Version to 4.7.3; Drop Priority: optional
    and Rules-Requires-Root: no.

 -- Boyuan Yang <byang@debian.org>  Sat, 07 Feb 2026 13:46:37 -0500

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,27 @@
 Source: kf6-extra-cmake-modules
 Section: devel
-Priority: optional
-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Patrick Franz <deltaone@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
                cmake (>= 3.16~),
-               libjs-jquery (>= 3.5.1+dfsg-3) <!nodoc>,
-               libjs-underscore <!nodoc>,
-               python3-setuptools <!nodoc>,
-               python3-sphinx (>= 1.2~) <!nodoc>,
-               python3-sphinxcontrib.qthelp <!nodoc>,
-               python3-sphinxcontrib.serializinghtml <!nodoc>,
+               python3-sphinx:native (>= 1.2~) <!nodoc>,
+               python3-sphinxcontrib.qthelp:native <!nodoc>,
+               qt6-tools-dev,
+               qtbase5-dev,
+               qtdeclarative5-dev,
+               qttools5-dev-tools,
 Build-Depends-Indep: dh-sequence-sphinxdoc,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+                     libjs-jquery (>= 3.5.1+dfsg-3) <!nodoc>,
+                     libjs-underscore <!nodoc>,
+                     python3-setuptools <!nodoc>,
+                     python3-sphinxcontrib.serializinghtml <!nodoc>,
+Standards-Version: 4.7.3
 Homepage: https://invent.kde.org/frameworks/extra-cmake-modules
-Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-extra-cmake-modules
-Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-extra-cmake-modules
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-extra-cmake-modules
+Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-extra-cmake-modules.git
 
 Package: extra-cmake-modules
 Architecture: any
@@ -43,7 +44,8 @@
 Multi-Arch: foreign
 Section: doc
 Built-Using: ${sphinxdoc:Built-Using},
-Depends: ${misc:Depends}, ${sphinxdoc:Depends},
+Depends: ${misc:Depends},
+         ${sphinxdoc:Depends},
 Description: Extra modules and scripts for CMake - documentation
  Extra CMake Modules, or ECM, aims to augment CMake with additional modules. It
  serves as both a staging ground for new modules before they are moved upstream

## kf6-extra-cmake-modules 6.22.0+p24.04+vstable+git20260106.0712

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0+p24.04+vstable+git20260106.0712-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 06 Jan 2026 07:12:11 +0000

kf6-extra-cmake-modules (6.22.0-0neon) Noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Tue, 06 Jan 2026 16:45:35 +1000

## kf6-extra-cmake-modules 6.22.0+p24.04+vstable+git20260106.0848

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0+p24.04+vstable+git20260106.0848-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 06 Jan 2026 08:48:24 +0000

## kf6-extra-cmake-modules 6.22.0+p24.04+vstable+git20260116.0203

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 # SPDX-License-Identifier: BSD-3-Clause
 #=============================================================================
 
-cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.16)
 
 #
 # Preliminary setup
 #
 
-set(VERSION "6.22.0") # handled by release scripts
+set(VERSION "6.23.0") # handled by release scripts
 
 project(ECM
     VERSION "${VERSION}"

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0+p24.04+vstable+git20260116.0203-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 16 Jan 2026 02:03:09 +0000

## kf6-extra-cmake-modules 6.22.0+p24.04+vstable+git20260122.1216

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0+p24.04+vstable+git20260122.1216-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 22 Jan 2026 12:16:34 +0000

## kf6-extra-cmake-modules 6.22.0+p24.04+vunstable+git20260111.0040

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0+p24.04+vunstable+git20260111.0040-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 11 Jan 2026 00:40:44 +0000

## kf6-extra-cmake-modules 6.22.0+p24.04+vunstable+git20260123.0127

=== debian/changelog ===
kf6-extra-cmake-modules (6.22.0+p24.04+vunstable+git20260123.0127-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 23 Jan 2026 01:27:18 +0000

## kf6-extra-cmake-modules 6.23.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # SPDX-License-Identifier: BSD-3-Clause
 #=============================================================================
 
-cmake_minimum_required(VERSION 3.16)
+cmake_minimum_required(VERSION 3.27)
 
 #
 # Preliminary setup

=== tests/ECMAddTests/nameprefix_by_path_tests/dir_a/dir_notignored/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
# SPDX-License-Identifier: CC0-1.0

list(APPEND ECM_TEST_NAME_PREFIX_IGNORE_DIRS "dir_notignored")
ecm_test_set_dir_properties(PREFIX_NAME_NOT_IGNORE)

# prefix preset by path-derived value
ecm_add_test(
    TEST_NAME "main_notignored1"
    ${main_cpp}
)

# override of path-derived value by explicit arg
ecm_add_test(
    NAME_PREFIX "override_by_arg-"
    TEST_NAME "main_notignored2"
    ${main_cpp}
)

# override of path-derived value by explicit NO_NAME_PREFIX
ecm_add_test(
    NO_NAME_PREFIX
    TEST_NAME "main_notignored3"
    ${main_cpp}
)

# check
assert_test_name_prefix("dir_a-dir_notignored-")

assert_test_name("dir_a-dir_notignored-" "main_notignored1")
assert_test_name("override_by_arg-" "main_notignored2")
assert_test_name("" "main_notignored3")

=== tests/ECMAddTests/nameprefix_by_path_tests/dir_a/dir_first/dir_last/dir_afterlast/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
# SPDX-License-Identifier: CC0-1.0

# prefix preset by path-derived value
ecm_add_test(
    TEST_NAME "main_afterlast"
    ${main_cpp}
)

# override of path-derived value by explicit arg
ecm_add_test(
    NAME_PREFIX "override_by_arg-"
    TEST_NAME "main_afterlast2"
    ${main_cpp}
)

# check
assert_test_name_prefix("dir_first-dir_last-")

assert_test_name("dir_first-dir_last-" "main_afterlast")
assert_test_name("override_by_arg-" "main_afterlast2")

=== debian/changelog ===
kf6-extra-cmake-modules (6.23.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (6.23.0).
  * Update build-deps and deps with the info from cmake.
  * Add/update Nicolas Fella’s key in upstream keyring.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 21 Feb 2026 16:47:43 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
-               cmake (>= 3.16~),
+               cmake (>= 3.27~),
                python3-sphinx:native (>= 1.2~) <!nodoc>,
                python3-sphinxcontrib.qthelp:native <!nodoc>,
                qt6-tools-dev,

=== debian/watch ===
Version: 5

Source: https://download.kde.org/stable/frameworks/([\d\.]*)/
Matching-Pattern: extra-cmake-modules-(.*)\.tar\.xz
Pgpsigurlmangle: s/$/.sig/
